' 
'
'                             PB Main Template

    #include "\pbwin80\include\win32api.inc"

    DECLARE FUNCTION wtok(ByVal pText as DWORD,ByVal pArray as DWORD) as DWORD
    DECLARE FUNCTION StrLen(ByVal item as DWORD) as DWORD
    DECLARE FUNCTION szCopy(ByVal src as DWORD,ByVal dst as DWORD) as DWORD

' 

FUNCTION PBmain as LONG

    LOCAL acnt as DWORD
    LOCAL lcnt as DWORD
    LOCAL arr  as DWORD
    LOCAL slen as DWORD
    LOCAL pcln as DWORD
    LOCAL ptxt as DWORD
    LOCAL buffer as ASCIIZ * 32768

    ptxt = VarPtr(buffer)

    pcln = GetCommandLine       ' get address of command line

    szCopy pcln,ptxt            ' copy the command line to a buffer
                                ' so you can modify the copy

  ' -----------------------------------------
  ' tokenise the words in the text as a DWORD
  ' array and return the array item count
  ' -----------------------------------------
    acnt = wtok(ptxt,ByVal VarPtr(arr))

  ' ------------------------------------------------------
  ' dimension an array of ASCIIZ pointers at address "arr"
  ' ------------------------------------------------------
    Dim warray(acnt) as ASCIIZ PTR at arr

  ' ---------------------------------------
  ' display the array members item by item.
  ' ---------------------------------------
    lcnt = 0
    Do
      StdOut @warray(lcnt)
      ! add lcnt, 1
    Loop while lcnt < acnt

    GlobalFree arr      ' release the memory allocated in "wtok"

    StdOut chr$(13,10)+"Press any key to exit ...."

    Do
    Loop While Inkey$ = ""


End FUNCTION

' 

FUNCTION wtok(ByVal pText as DWORD,ByVal pArray as DWORD) as DWORD

    #REGISTER NONE

    LOCAL var1 as DWORD
    LOCAL var2 as DWORD

  ' -------------------------------------------------
  ' tokenise an array of words based on the character
  ' range specified in the following table and return
  ' an array of pointers to the tokens.
  ' -------------------------------------------------
  ' Note that if you modify the table you should not change
  ' the single or double quote as their capacity is built
  ' into the following algorithm.
  '
  ' The memory handle to the pointer array written to the
  ' variable "pArray" should be released within the same
  ' scope as the variable with a call to GlobalFree().
  ' -------------------------------------------------------

    ! xor ebx, ebx                    ' zero the array counter

    StrLen pText                      ' get the buffer length
    ! add eax, eax                    ' set pointer array size
    ! mov var1, eax

    GlobalAlloc %GMEM_FIXED or %GMEM_ZEROINIT,var1    ' allocate pointer array      
    ! mov edx, eax

  ' ======================
    ! mov esi, pText                  ' text address in ESI
    ! sub esi, 1
    ! mov edi, edx                    ' array address in EDI
  ' ======================

  badchar:
    ! add esi, 1
    ! movzx eax, BYTE PTR [esi]       ' zero extend byte
    ! test eax, eax                   ' test for zero terminator
    ! jz endsrc                       ' exit on terminator
    ! cmp BYTE PTR chtbl[eax], 0      ' test if bad character in table
    ! je badchar                      ' loop back for next if it is

  ' ========
    ! mov [edi], esi                  ' write current location to pointer array
    ! add edi, 4                      ' set next array write location
    ! add ebx, 1                      ' increment the array counter
  ' ========

    ! cmp eax, 39                     ' is character a single quote ?
    ! je squote
    ! cmp eax, 34                     ' is character a double quote ?
    ! je dquote

  goodchar:
    ! add esi, 1
    ! movzx eax, BYTE PTR [esi]       ' zero extend byte
    ! test eax, eax                   ' test for zero terminator
    ! jz endsrc                       ' exit on terminator
    ! cmp BYTE PTR chtbl[eax], 0      ' test if bad character in table
    ! jne goodchar                    ' loop back for next if its not

  ' ========
    ! mov BYTE PTR [esi], 0           ' overwrite trailing bad char with zero
    ! jmp badchar
  ' ========

  squote:                             ' single quote
    ! add esi, 1
    ! movzx eax, BYTE PTR [esi]
    ! test eax, eax
    ! jz qterror
    ! sub eax, 39
    ! jnz squote

    ! add esi, 1
    ! mov BYTE PTR [esi], 0
    ! jmp badchar

  dquote:                             ' double quote
    ! add esi, 1
    ! movzx eax, BYTE PTR [esi]
    ! test eax, eax
    ! jz qterror
    ! sub eax, 34
    ! jnz dquote

    ! add esi, 1
    ! mov BYTE PTR [esi], 0
    ! jmp badchar

  ' ======================

  ' The label "qterror" currently resolves to the same address as the
  ' following label "endsrc" but it is put in place if a user wants to
  ' modify this algorithm to flag a quotation error in the source text

  qterror:
  ' ----------------------------------------
  ' write quotation error handling code here
  ' ----------------------------------------

  endsrc:

' -------------------------------------------------------------------------

  ' -------------------------
  ' multiply array count by 4
  ' -------------------------
    ! mov eax, ebx                    ' EBX is the array count
    ! add eax, eax
    ! add eax, eax

  ' ----------------------
  ' truncate unused memory
  ' ----------------------
    ! mov var1, eax
    ! mov var2, edx

    GlobalReAlloc var2,var1,0         ' EDX is the allocate memory handle being reallocated

  ' -----------------------------------
  ' copy the local array handle back
  ' to the address of the passed handle
  ' -----------------------------------
    ! mov esi, pArray                 ' load passed handle address into EDX
    ! mov DWORD PTR [esi], eax        ' store local array handle at address of passed handle

    ! mov FUNCTION, ebx               ' return the array member count
    EXIT FUNCTION

  chtbl:
    ! db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    ! db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    ! db 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1


END FUNCTION

' 

FUNCTION StrLen(ByVal item as DWORD) as DWORD

    #REGISTER NONE

    ! mov     eax, item               ' get pointer to string
    ! lea     edx, [eax+3]            ' pointer+3 used in the end
    ! mov     ebx, &H80808080

  lbl0:
  ' --------------------
  ' manually unroll by 3
  ' --------------------
    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt

    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt

    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt
  ' --------------------
    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' 4 increment DWORD pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jz      lbl0                    ' no zero bytes, continue loop

  nxt:
    ! test    ecx, &H00008080         ' test first two bytes
    ! jnz     lbl1
    ! shr     ecx, 16                 ' not in the first 2 bytes
    ! add     eax, 2
  lbl1:
    ! shl     cl, 1                   ' use carry flag to avoid branch
    ! sbb     eax, edx                ' compute length

    ! mov FUNCTION, eax

END FUNCTION

' 

FUNCTION szCopy(ByVal src as DWORD,ByVal dst as DWORD) as DWORD

    #REGISTER NONE

    ! mov esi, src
    ! mov edi, dst
    ! or ebx, -1

  ' -----------
  ' unroll by 4
  ' -----------
  lbl0:
    ! add ebx, 1
    ! movzx eax, BYTE PTR [esi+ebx]
    ! mov [edi+ebx], al
    ! test eax, eax
    ! jz lbl1

    ! add ebx, 1
    ! movzx eax, BYTE PTR [esi+ebx]
    ! mov [edi+ebx], al
    ! test eax, eax
    ! jz lbl1

    ! add ebx, 1
    ! movzx eax, BYTE PTR [esi+ebx]
    ! mov [edi+ebx], al
    ! test eax, eax
    ! jz lbl1

    ! add ebx, 1
    ! movzx eax, BYTE PTR [esi+ebx]
    ! mov [edi+ebx], al
    ! test eax, eax
    ! jnz lbl0

  lbl1:

END FUNCTION

' 















